## imsprog 1.3.9

=== IMSProg_editor/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.0)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

project(IMSProg_editor LANGUAGES CXX)

# Set the CMAKE_INSTALL_PREFIX to /usr if not specified
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
	set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "The default install prefix" FORCE)
endif()

# Set the CMAKE_INSTALL_BINDIR to /bin if not specified
if(NOT DEFINED CMAKE_INSTALL_BINDIR)
  set(CMAKE_INSTALL_BINDIR "bin" CACHE PATH "user executables (bin)")
endif()

# Set the CMAKE_INSTALL_DATAROOTDIR to /share if not specified
if(NOT DEFINED CMAKE_INSTALL_DATAROOTDIR)
  set(CMAKE_INSTALL_DATAROOTDIR "share" CACHE PATH "read-only architecture-independent data root (share)")
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

find_package(Qt5 REQUIRED COMPONENTS Core Widgets)
find_package(Qt5Widgets REQUIRED)

# Qt5LinguistTools
find_package(Qt5 REQUIRED COMPONENTS LinguistTools)

# Translation files
set(TS_FILES
    language/chipEditor_ru_RU.ts
    language/chipEditor_de_DE.ts
    language/chipEditor_es_ES.ts
    language/chipEditor_zh_CN.ts
    language/chipEditor_uk_UA.ts
    language/chipEditor_hu_HU.ts
    language/chipEditor_pt_BR.ts
    language/chipEditor_it_IT.ts
)

qt5_add_translation(QM_FILES ${TS_FILES})
add_custom_target(translations1 DEPENDS ${QM_FILES})

add_executable(${PROJECT_NAME}
	ezp_chip_editor.h
	ezp_chip_editor.cpp
	ezp_chip_editor.ui
	main.cpp
	delegates.h
	delegates.cpp
	resources.qrc
	${QM_FILES}
	)


target_include_directories(${PROJECT_NAME} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(${PROJECT_NAME} Qt5::Core)
target_link_libraries(${PROJECT_NAME} Qt5::Widgets)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg_editor.desktop" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/img/chipEdit64.png" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/pixmaps")

install(FILES ${QM_FILES} DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/imsprog")

install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg_editor.1.gz" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/man/man1")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/imsprog.editor.appdata.xml" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo")

=== IMSProg_programmer/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.0)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

project(IMSProg LANGUAGES C CXX)

# Set the CMAKE_INSTALL_PREFIX to /usr if not specified
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
	set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "The default install prefix" FORCE)
endif()

# Set the CMAKE_INSTALL_BINDIR to /bin if not specified
if(NOT DEFINED CMAKE_INSTALL_BINDIR)
  set(CMAKE_INSTALL_BINDIR "bin" CACHE PATH "user executables (bin)")
endif()

# Set the CMAKE_INSTALL_DATAROOTDIR to /share if not specified
if(NOT DEFINED CMAKE_INSTALL_DATAROOTDIR)
  set(CMAKE_INSTALL_DATAROOTDIR "share" CACHE PATH "read-only architecture-independent data root (share)")
endif()

# Set the CMAKE_INSTALL_LIBDIR to /lib if not specified
if(NOT DEFINED CMAKE_INSTALL_LIBDIR)
  set(CMAKE_INSTALL_LIBDIR "/lib" CACHE PATH "read-only single-machine data (lib)")
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

find_package(Qt5 REQUIRED COMPONENTS Core Widgets)
find_package(Qt5Widgets REQUIRED)
find_package(LibUSB REQUIRED)

set(UDEVDIR "/usr/lib/udev")
if (CMAKE_INSTALL_PREFIX STREQUAL "/usr" OR CMAKE_INSTALL_PREFIX STREQUAL "/" )
# /usr and / install prefixes at treated by cmake GNUInstallDirs as
# synonym for "system location". In this case we can look up the correct udevdir
# using pkg-config.
# See: https://cmake.org/cmake/help/latest/module/GNUInstallDirs.html#special-cases
find_package(PkgConfig)
  if (PKG_CONFIG_FOUND)
    pkg_check_modules( PKGCONFIG_UDEV udev)
    if (PKGCONFIG_UDEV_FOUND)
      execute_process(
        COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=udevdir udev
          OUTPUT_VARIABLE PKGCONFIG_UDEVDIR
          OUTPUT_STRIP_TRAILING_WHITESPACE
      )
      if(PKGCONFIG_UDEVDIR)
        file(TO_CMAKE_PATH "${PKGCONFIG_UDEVDIR}" UDEVDIR)
      endif()
    endif()
  endif()
endif()
	
# Qt5LinguistTools
find_package(Qt5 REQUIRED COMPONENTS LinguistTools)

# Translation files
set(TS_FILES
    language/chipProgrammer_ru_RU.ts
    language/chipProgrammer_de_DE.ts
    language/chipProgrammer_es_ES.ts
    language/chipProgrammer_zh_CN.ts
    language/chipProgrammer_uk_UA.ts
    language/chipProgrammer_hu_HU.ts
    language/chipProgrammer_pt_BR.ts
    language/chipProgrammer_it_IT.ts
)

qt5_add_translation(QM_FILES ${TS_FILES})
add_custom_target(translations DEPENDS ${QM_FILES})

add_executable(${PROJECT_NAME}

main.cpp
mainwindow.cpp
qhexedit.cpp
chunks.cpp
commands.cpp
dialogsp.cpp
dialogrp.cpp
dialogsfdp.cpp
dialogsr.cpp
dialogsetaddr.cpp
searchdialog.cpp
dialoginfo.cpp
bitbang_microwire.c
ch341a_gpio.c
ch341a_i2c.c
ch341a_spi.c
flashcmd_api.c
i2c_eeprom.c
mw_eeprom.c
spi_controller.c
spi_eeprom.c
spi_nand_flash.c
spi_nor_flash.c
timer.c
dialogabout.cpp
mainwindow.h
qhexedit.h
chunks.h
commands.h
dialogsp.h
dialogrp.h
dialogsfdp.h
dialogsr.h
dialoginfo.h
dialogsetaddr.h
searchdialog.h
bitbang_microwire.h
ch341a_gpio.h
ch341a_i2c.h
ch341a_spi.h
flashcmd_api.h
i2c_eeprom_api.h
mw_eeprom_api.h
nandcmd_api.h
res.h
snorcmd_api.h
spi_controller.h
spi_eeprom.h
spi_eeprom_api.h
spi_nand_flash.h
timer.h
types.h
dialogabout.h
mainwindow.ui
dialogsp.ui
dialogrp.ui
dialogsfdp.ui
dialogsr.ui
dialogsetaddr.ui
dialoginfo.ui
searchdialog.ui
dialogabout.ui
recource.qrc
${QM_FILES}
)
	
target_include_directories(${PROJECT_NAME} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(${PROJECT_NAME} Qt5::Core)
target_link_libraries(${PROJECT_NAME} Qt5::Widgets ${LibUSB_LIBRARIES})

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg.desktop" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/img/IMSProg64.png" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/pixmaps")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/database/IMSProg.Dat" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/imsprog")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/99-CH341.rules" DESTINATION "${UDEVDIR}/rules.d")

install(FILES ${QM_FILES} DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/imsprog")

install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg_database_update" 
PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg_database_update.desktop" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/img/IMSProg_database_update.png" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/pixmaps")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg.1.gz" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/man/man1")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg_database_update.1.gz" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/man/man1")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/index.html" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/doc/imsprog/html")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/imsprog.appdata.xml" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/imsprog.database.update.appdata.xml" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo")

#Reloading USB UDEV rules
execute_process(
    COMMAND bash "-c" "sudo udevadm control --reload-rules" 
    OUTPUT_VARIABLE FOO
)

=== debian/changelog ===
imsprog (1.3.9-1) unstable; urgency=medium

  * New upstream version (Closes: #1070883)
  * Update debian/copyright
  * d/control: add qttools5-dev to build-deps
  * d/rules: add all hardening
  * Bump debhelper compat to 13
  * Bump Standards-Version to 4.7.0, no needed changes

 -- Mikhail Medvedev <e-ink-reader@yandex.ru>  Mon, 13 May 2024 15:09:18 +0300

imsprog (1.3.2-1) unstable; urgency=medium

  * Initial release (Closes: #1057386)

 -- Mikhail Medvedev <e-ink-reader@yandex.ru>  Mon, 26 Feb 2024 13:16:51 +0300

=== debian/watch ===
version=4
https://github.com/bigbigmdm/IMSProg/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@

## imsprog 1.4.3

=== IMSProg_editor/CMakeLists.txt ===
--- 
+++ 
@@ -70,4 +70,4 @@
 install(FILES ${QM_FILES} DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/imsprog")
 
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg_editor.1.gz" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/man/man1")
-install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/imsprog.editor.appdata.xml" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo")
+install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/io.github.bigbigmdm.imsprog_editor.metainfo.xml" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo")

=== IMSProg_programmer/CMakeLists.txt ===
--- 
+++ 
@@ -151,7 +151,7 @@
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg.desktop" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications")
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/img/IMSProg64.png" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/pixmaps")
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/database/IMSProg.Dat" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/imsprog")
-install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/99-CH341.rules" DESTINATION "${UDEVDIR}/rules.d")
+install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/71-CH341.rules" DESTINATION "${UDEVDIR}/rules.d")
 
 install(FILES ${QM_FILES} DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/imsprog")
 
@@ -163,11 +163,6 @@
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg.1.gz" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/man/man1")
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg_database_update.1.gz" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/man/man1")
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/index.html" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/doc/imsprog/html")
-install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/imsprog.appdata.xml" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo")
-install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/imsprog.database.update.appdata.xml" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo")
+install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/io.github.bigbigmdm.imsprog.metainfo.xml" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo")
+install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/io.github.bigbigmdm.imsprog_database_update.metainfo.xml" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo")
 
-#Reloading USB UDEV rules
-execute_process(
-    COMMAND bash "-c" "sudo udevadm control --reload-rules" 
-    OUTPUT_VARIABLE FOO
-)

=== debian/changelog ===
imsprog (1.4.3-1) unstable; urgency=medium

  * New upstream version:
    - Fix: On the GNOME desktop, program does not respond
      when erasing SPI NOR FLASH

 -- Mikhail Medvedev <e-ink-reader@yandex.ru>  Fri, 26 Jul 2024 11:51:43 +0300

imsprog (1.4.2-1) unstable; urgency=medium

  * New upstream version
  * Update debian/copyright
  * Fix metadata files

 -- Mikhail Medvedev <e-ink-reader@yandex.ru>  Fri, 28 Jun 2024 09:55:04 +0300

imsprog (1.4.1-1) unstable; urgency=medium

  * New upstream version
    - Renamed udev rule from 99-CH341.rules to 71-CH341.rules (for uaccess)
      and removed MODE=660 and GROUP+=plugdev
  * Fix debian/watch

 -- Mikhail Medvedev <e-ink-reader@yandex.ru>  Mon, 27 May 2024 13:03:27 +0300

## imsprog 1.4.4

=== IMSProg_programmer/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,13 @@
 
 # Set the CMAKE_INSTALL_PREFIX to /usr if not specified
 if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
-	set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "The default install prefix" FORCE)
+  if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+      set(CMAKE_INSTALL_PREFIX "/usr/local" CACHE PATH "The default install prefix on macOS" FORCE)
+  # Set Qt5 path for macOS
+  	set(CMAKE_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}/opt/qt@5" CACHE PATH "Path to Qt5 on macOS" FORCE)
+  else()
+      set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "The default install prefix" FORCE)
+  endif()
 endif()
 
 # Set the CMAKE_INSTALL_BINDIR to /bin if not specified
@@ -35,6 +41,7 @@
 find_package(Qt5Widgets REQUIRED)
 find_package(LibUSB REQUIRED)
 
+if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
 set(UDEVDIR "/usr/lib/udev")
 if (CMAKE_INSTALL_PREFIX STREQUAL "/usr" OR CMAKE_INSTALL_PREFIX STREQUAL "/" )
 # /usr and / install prefixes at treated by cmake GNUInstallDirs as
@@ -56,7 +63,7 @@
     endif()
   endif()
 endif()
-	
+endif()
 # Qt5LinguistTools
 find_package(Qt5 REQUIRED COMPONENTS LinguistTools)
 
@@ -142,20 +149,23 @@
 recource.qrc
 ${QM_FILES}
 )
-	
+
 target_include_directories(${PROJECT_NAME} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
 target_link_libraries(${PROJECT_NAME} Qt5::Core)
 target_link_libraries(${PROJECT_NAME} Qt5::Widgets ${LibUSB_LIBRARIES})
 
 install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
-install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg.desktop" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications")
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/img/IMSProg64.png" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/pixmaps")
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/database/IMSProg.Dat" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/imsprog")
-install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/71-CH341.rules" DESTINATION "${UDEVDIR}/rules.d")
+
+if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+  install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg.desktop" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications")
+  install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/71-CH341.rules" DESTINATION "${UDEVDIR}/rules.d")
+endif()
 
 install(FILES ${QM_FILES} DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/imsprog")
 
-install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg_database_update" 
+install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg_database_update"
 PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
 DESTINATION ${CMAKE_INSTALL_BINDIR})
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg_database_update.desktop" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications")
@@ -165,4 +175,3 @@
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/index.html" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/doc/imsprog/html")
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/io.github.bigbigmdm.imsprog.metainfo.xml" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo")
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/io.github.bigbigmdm.imsprog_database_update.metainfo.xml" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo")
-

=== debian/changelog ===
imsprog (1.4.4-1) unstable; urgency=medium

  * New upstream version:
    - Fix: incorrect reading of the DataFlash chips status register

 -- Mikhail Medvedev <e-ink-reader@yandex.ru>  Mon, 23 Sep 2024 13:31:07 +0300

## imsprog 1.4.5

=== debian/changelog ===
imsprog (1.4.5-1) unstable; urgency=medium

  * New upstream version:
    - Fix: Incorrect block/page size after first read procedure
    - Fix: Incorrect reading/writing I2C low speed chips
 -- Mikhail Medvedev <e-ink-reader@yandex.ru>  Mon, 20 Jan 2025 08:54:31 +0300

## imsprog 1.5.1

=== debian/changelog ===
imsprog (1.5.1-1) unstable; urgency=medium

  * New upstream version:
    - Fix: Incorrect install dir for udev while cross compiling
    - Add: Form for working with security registers for SPI NOR flash chips
 -- Mikhail Medvedev <e-ink-reader@yandex.ru>  Fri, 21 Feb 2025 09:44:22 +0300
 

## imsprog 1.5.2

=== IMSProg_programmer/CMakeLists.txt ===
--- 
+++ 
@@ -43,7 +43,7 @@
 
 if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
 set(UDEVDIR "/usr/lib/udev")
-if (CMAKE_INSTALL_PREFIX STREQUAL "/usr" OR CMAKE_INSTALL_PREFIX STREQUAL "/" )
+if (CMAKE_INSTALL_PREFIX STREQUAL "/usr" OR CMAKE_INSTALL_PREFIX STREQUAL "/" AND NOT CMAKE_CROSSCOMPILING)
 # /usr and / install prefixes at treated by cmake GNUInstallDirs as
 # synonym for "system location". In this case we can look up the correct udevdir
 # using pkg-config.
@@ -92,6 +92,7 @@
 dialogsp.cpp
 dialogrp.cpp
 dialogsfdp.cpp
+dialogsecurity.cpp
 dialogsr.cpp
 dialogsetaddr.cpp
 searchdialog.cpp
@@ -116,6 +117,7 @@
 dialogsp.h
 dialogrp.h
 dialogsfdp.h
+dialogsecurity.h
 dialogsr.h
 dialoginfo.h
 dialogsetaddr.h
@@ -141,6 +143,7 @@
 dialogsp.ui
 dialogrp.ui
 dialogsfdp.ui
+dialogsecurity.ui
 dialogsr.ui
 dialogsetaddr.ui
 dialoginfo.ui

=== debian/changelog ===
imsprog (1.5.2-1) unstable; urgency=medium

  * New upstream version:
    - Fix: Memory leaks
    - Fix: Gigadevice status registers write error
    - Add: New SPI chip sizes
    - Add: Fidelix, Zetta, MXIC OTP algorithm
 -- Mikhail Medvedev <e-ink-reader@yandex.ru>  Wed, 05 Mar 2025 13:29:41 +0300

=== debian/control ===
Source: imsprog
Section: devel
Priority: optional
Maintainer: Mikhail Medvedev <e-ink-reader@yandex.ru>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libusb-1.0-0-dev,
 pkgconf,
 qtbase5-dev,
 qttools5-dev,
 systemd-dev (>= 253-2~) | udev (<< 253-2~),
Standards-Version: 4.7.0
Homepage: https://github.com/bigbigmdm/IMSProg
Vcs-Git: https://github.com/bigbigmdm/IMSProg.git -b debian/latest
Vcs-Browser: https://github.com/bigbigmdm/IMSProg/
Rules-Requires-Root: no

Package: imsprog
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: wget, zenity
Description: Linux chip programmer for CH341a devices
 Linux IMSProg - I2C, SPI and MicroWire chip programmer for CH341a devices.
 The IMSProg is a free EEPROM programmer tool for CH341A device based on
 QhexEdit2 and modify SNANDer programmer.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

=== debian/watch ===
version=4
https://github.com/bigbigmdm/IMSProg/tags .*/v@ANY_VERSION@@ARCHIVE_EXT@

## imsprog 1.6.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.0)

add_subdirectory("IMSProg_programmer")
add_subdirectory("IMSProg_editor")

=== IMSProg_editor/CMakeLists.txt ===
--- 
+++ 
@@ -8,10 +8,15 @@
 set(CMAKE_AUTOUIC ON)
 
 project(IMSProg_editor LANGUAGES CXX)
-
-# Set the CMAKE_INSTALL_PREFIX to /usr if not specified
+# Set the CMAKE_INSTALL_PREFIX to /usr if not specified and /usr/local for macOS
 if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
-	set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "The default install prefix" FORCE)
+  if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+      set(CMAKE_INSTALL_PREFIX "/usr/local" CACHE PATH "The default install prefix on macOS" FORCE)
+  # Set Qt5 path for macOS
+  	set(CMAKE_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}/opt/qt@5" CACHE PATH "Path to Qt5 on macOS" FORCE)
+  else()
+      set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "The default install prefix" FORCE)
+  endif()
 endif()
 
 # Set the CMAKE_INSTALL_BINDIR to /bin if not specified
@@ -64,7 +69,11 @@
 target_link_libraries(${PROJECT_NAME} Qt5::Widgets)
 
 install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
-install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg_editor.desktop" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications")
+
+if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+	install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/other/IMSProg_editor.desktop" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications")
+endif()
+
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/img/chipEdit64.png" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/pixmaps")
 
 install(FILES ${QM_FILES} DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/imsprog")

=== IMSProg_programmer/CMakeLists.txt ===
--- 
+++ 
@@ -93,14 +93,17 @@
 dialogrp.cpp
 dialogsfdp.cpp
 dialogsecurity.cpp
+dialogcompare.cpp
 dialogsr.cpp
 dialogsetaddr.cpp
+hexutility.cpp
 searchdialog.cpp
 dialoginfo.cpp
 bitbang_microwire.c
 ch341a_gpio.c
 ch341a_i2c.c
 ch341a_spi.c
+color_manager.cpp
 flashcmd_api.c
 i2c_eeprom.c
 mw_eeprom.c
@@ -114,13 +117,16 @@
 qhexedit.h
 chunks.h
 commands.h
+color_manager.h
 dialogsp.h
 dialogrp.h
 dialogsfdp.h
 dialogsecurity.h
+dialogcompare.h
 dialogsr.h
 dialoginfo.h
 dialogsetaddr.h
+hexutility.h
 searchdialog.h
 bitbang_microwire.h
 ch341a_gpio.h
@@ -144,6 +150,7 @@
 dialogrp.ui
 dialogsfdp.ui
 dialogsecurity.ui
+dialogcompare.ui
 dialogsr.ui
 dialogsetaddr.ui
 dialoginfo.ui

=== debian/changelog ===
imsprog (1.6.2-1) unstable; urgency=medium

  * New upstream version:
    - Fix: program crashed if security registers was less than 256 bytes
    - Fix: Information in the status bar disappears when hovering over a menu
    - Added comparison of INTEL HEX and ASUS CAP with other files
    - Added close and minimise buttons for subordinate forms
    - New chips added to database
    - Chip information form code optimized
 -- Mikhail Medvedev <e-ink-reader@yandex.ru>  Tue, 1 Jul 2025 11:32:27 +0300

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  qtbase5-dev,
  qttools5-dev,
  systemd-dev (>= 253-2~) | udev (<< 253-2~),
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/bigbigmdm/IMSProg
 Vcs-Git: https://github.com/bigbigmdm/IMSProg.git -b debian/latest
 Vcs-Browser: https://github.com/bigbigmdm/IMSProg/

## imsprog 1.7.1

=== IMSProg_editor/CMakeLists.txt ===
--- 
+++ 
@@ -43,6 +43,7 @@
     language/chipEditor_de_DE.ts
     language/chipEditor_es_ES.ts
     language/chipEditor_zh_CN.ts
+    language/chipEditor_zh_TW.ts
     language/chipEditor_uk_UA.ts
     language/chipEditor_hu_HU.ts
     language/chipEditor_pt_BR.ts

=== IMSProg_programmer/CMakeLists.txt ===
--- 
+++ 
@@ -73,6 +73,7 @@
     language/chipProgrammer_de_DE.ts
     language/chipProgrammer_es_ES.ts
     language/chipProgrammer_zh_CN.ts
+    language/chipProgrammer_zh_TW.ts
     language/chipProgrammer_uk_UA.ts
     language/chipProgrammer_hu_HU.ts
     language/chipProgrammer_pt_BR.ts
@@ -89,10 +90,13 @@
 qhexedit.cpp
 chunks.cpp
 commands.cpp
+dialogbbm.cpp
 dialogsp.cpp
 dialogrp.cpp
 dialogsfdp.cpp
+dialognandsr.cpp
 dialogsecurity.cpp
+dialognandsecurity.cpp
 dialogcompare.cpp
 dialogsr.cpp
 dialogsetaddr.cpp
@@ -118,10 +122,13 @@
 chunks.h
 commands.h
 color_manager.h
+dialogbbm.h
 dialogsp.h
 dialogrp.h
 dialogsfdp.h
 dialogsecurity.h
+dialognandsecurity.h
+dialognandsr.h
 dialogcompare.h
 dialogsr.h
 dialoginfo.h
@@ -146,10 +153,13 @@
 types.h
 dialogabout.h
 mainwindow.ui
+dialogbbm.ui
 dialogsp.ui
 dialogrp.ui
 dialogsfdp.ui
+dialognandsr.ui
 dialogsecurity.ui
+dialognandsecurity.ui
 dialogcompare.ui
 dialogsr.ui
 dialogsetaddr.ui

=== debian/changelog ===
imsprog (1.7.1-1) unstable; urgency=medium

  * New upstream version:
    - Fix: pressing the Stop key did not stop auto operations
    - Added support for SPI NAND flash
    - traditional chinese translation added
    - copyright information changed
 -- Mikhail Medvedev <e-ink-reader@yandex.ru>  Wed, 5 Nov 2025 13:55:14 +0300

## imsprog 1.7.2

=== debian/changelog ===
imsprog (1.7.2-1) unstable; urgency=medium

  * New upstream version:
    - Fix: NAND Flash information form freeze
    - Added support for AT24CM02
    - Programmer type menu added
    - New images added for CH341A v1.7
 -- Mikhail Medvedev <e-ink-reader@yandex.ru>  Tue, 25 Nov 2025 10:11:47 +0300

## imsprog 1.7.3

=== debian/changelog ===
imsprog (1.7.3-1) unstable; urgency=medium

  * New upstream version:
    - Fix: Incorrect HexEdit size when starting the program
    - Added: saving program settings to an ini file
 -- Mikhail Medvedev <e-ink-reader@yandex.ru>  Fri, 6 Feb 2026 08:15:21 +0300

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  qtbase5-dev,
  qttools5-dev,
  systemd-dev (>= 253-2~) | udev (<< 253-2~),
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://github.com/bigbigmdm/IMSProg
 Vcs-Git: https://github.com/bigbigmdm/IMSProg.git -b debian/latest
 Vcs-Browser: https://github.com/bigbigmdm/IMSProg/
